from sqlalchemy.ext.asyncio import AsyncSession
from typing import List
from config.constant import CommonConstant
from exceptions.exception import ServiceException
from module_admin.entity.vo.common_vo import CrudResponseModel
from module_admin.dao.sys_alert_dao import Sys_alertDao
from module_admin.entity.vo.sys_alert_vo import DeleteSys_alertModel, Sys_alertModel, Sys_alertPageQueryModel
from utils.common_util import CamelCaseUtil
from utils.excel_util import ExcelUtil


class Sys_alertService:
    """
    系统告警模块服务层
    """

    @classmethod
    async def get_sys_alert_list_services(
        cls, query_db: AsyncSession, query_object: Sys_alertPageQueryModel, is_page: bool = False
    ):
        """
        获取系统告警列表信息service

        :param query_db: orm对象
        :param query_object: 查询参数对象
        :param is_page: 是否开启分页
        :return: 系统告警列表信息对象
        """
        sys_alert_list_result = await Sys_alertDao.get_sys_alert_list(query_db, query_object, is_page)

        return sys_alert_list_result


    @classmethod
    async def add_sys_alert_services(cls, query_db: AsyncSession, page_object: Sys_alertModel):
        """
        新增系统告警信息service

        :param query_db: orm对象
        :param page_object: 新增系统告警对象
        :return: 新增系统告警校验结果
        """
        try:
            await Sys_alertDao.add_sys_alert_dao(query_db, page_object)
            await query_db.commit()
            return CrudResponseModel(is_success=True, message='新增成功')
        except Exception as e:
            await query_db.rollback()
            raise e

    @classmethod
    async def edit_sys_alert_services(cls, query_db: AsyncSession, page_object: Sys_alertModel):
        """
        编辑系统告警信息service

        :param query_db: orm对象
        :param page_object: 编辑系统告警对象
        :return: 编辑系统告警校验结果
        """
        edit_sys_alert = page_object.model_dump(exclude_unset=True, exclude={'create_time', 'create_by', })
        sys_alert_info = await cls.sys_alert_detail_services(query_db, page_object.id)
        if sys_alert_info.id:
            try:
                await Sys_alertDao.edit_sys_alert_dao(query_db, edit_sys_alert)
                await query_db.commit()
                return CrudResponseModel(is_success=True, message='更新成功')
            except Exception as e:
                await query_db.rollback()
                raise e
        else:
            raise ServiceException(message='系统告警不存在')

    @classmethod
    async def delete_sys_alert_services(cls, query_db: AsyncSession, page_object: DeleteSys_alertModel):
        """
        删除系统告警信息service

        :param query_db: orm对象
        :param page_object: 删除系统告警对象
        :return: 删除系统告警校验结果
        """
        if page_object.ids:
            id_list = page_object.ids.split(',')
            try:
                for id in id_list:
                    await Sys_alertDao.delete_sys_alert_dao(query_db, Sys_alertModel(id=id))
                await query_db.commit()
                return CrudResponseModel(is_success=True, message='删除成功')
            except Exception as e:
                await query_db.rollback()
                raise e
        else:
            raise ServiceException(message='传入主键 自增为空')

    @classmethod
    async def sys_alert_detail_services(cls, query_db: AsyncSession, id: int):
        """
        获取系统告警详细信息service

        :param query_db: orm对象
        :param id: 主键 自增
        :return: 主键 自增对应的信息
        """
        sys_alert = await Sys_alertDao.get_sys_alert_detail_by_id(query_db, id=id)
        if sys_alert:
            result = Sys_alertModel(**CamelCaseUtil.transform_result(sys_alert))
        else:
            result = Sys_alertModel(**dict())

        return result

    @staticmethod
    async def export_sys_alert_list_services(sys_alert_list: List):
        """
        导出系统告警信息service

        :param sys_alert_list: 系统告警信息列表
        :return: 系统告警信息对应excel的二进制数据
        """
        # 创建一个映射字典，将英文键映射到中文键
        mapping_dict = {
            'id': '主键 自增',
            'detail': '告警描述',
            'type': '告警类型',
            'status': '告警状态, 0 未处理, 1 已处理',
            'createTime': '创建时间',
            'createBy': '创建者',
            'updateTime': '更新时间',
            'updateBy': '更新者',
        }
        binary_data = ExcelUtil.export_list2excel(sys_alert_list, mapping_dict)

        return binary_data
